#!/usr/bin/env python

from datetime import datetime

from aman.config.AirportSequencing import AirportSequencing

class Configuration:
    def __init__(self, **kwargs):
        # the AMAN specific information
        self.RunwayConstraints = kwargs.get('constraints', None)
        self.PreceedingInbounds = kwargs.get('preceeding', None)
        self.Inbounds = kwargs.get('inbounds', None)
        self.EarliestArrivalTime = kwargs.get('earliest', None)
        self.WeatherModel = kwargs.get('weather', None)

        # the ACO specific information
        self.AntCount = kwargs.get('ants', 20)
        self.ExplorationRuns = kwargs.get('generations', 20)
        self.PheromoneEvaporationRate = 0.9
        self.PseudoRandomSelectionRate = 0.9
        self.propagationRatio = 0.9
        self.Epsilon = 0.1
        self.RunwayOccupasionRatio = 0.7
        self.Beta = 2.0
        self.ThetaZero = None